lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [<thread-prev] [day] [month] [year] [list]
Date: Tue, 12 Dec 2023 16:38:45 -0800
From: David Wei <dw@...idwei.uk>
To: Jakub Kicinski <kuba@...nel.org>
Cc: Jiri Pirko <jiri@...nulli.us>, Sabrina Dubroca <sd@...asysnail.net>,
 netdev@...r.kernel.org, "David S. Miller" <davem@...emloft.net>,
 Eric Dumazet <edumazet@...gle.com>, Paolo Abeni <pabeni@...hat.com>
Subject: Re: [PATCH net-next v2 3/3] netdevsim: add selftest for forwarding
 skb between connected ports

On 2023-12-12 12:29, Jakub Kicinski wrote:
> On Sat,  9 Dec 2023 17:04:48 -0800 David Wei wrote:
>> From: David Wei <davidhwei@...a.com>
>>
>> Connect two netdevsim ports in different namespaces together, then send
>> packets between them using socat.
>>
>> Signed-off-by: David Wei <dw@...idwei.uk>
>> ---
>>  .../selftests/drivers/net/netdevsim/peer.sh   | 111 ++++++++++++++++++
>>  1 file changed, 111 insertions(+)
>>  create mode 100755 tools/testing/selftests/drivers/net/netdevsim/peer.sh
> 
> You need to include this script in the Makefile so it gets run

Thanks, will address.

> 
>> diff --git a/tools/testing/selftests/drivers/net/netdevsim/peer.sh b/tools/testing/selftests/drivers/net/netdevsim/peer.sh
>> new file mode 100755
>> index 000000000000..d1d59a932174
>> --- /dev/null
>> +++ b/tools/testing/selftests/drivers/net/netdevsim/peer.sh
>> @@ -0,0 +1,111 @@
>> +#!/bin/bash
>> +# SPDX-License-Identifier: GPL-2.0-only
>> +
>> +NSIM_DEV_SYS=/sys/bus/netdevsim
>> +NSIM_DEV_DFS=/sys/kernel/debug/netdevsim/netdevsim
>> +
>> +socat_check()
>> +{
>> +	if [ ! -x "$(command -v socat)" ]; then
>> +		echo "socat command not found. Skipping test"
>> +		return 1
>> +	fi
>> +
>> +	return 0
>> +}
>> +
>> +setup_ns()
>> +{
>> +	set -e
>> +	ip netns add nssv
>> +	ip netns add nscl
>> +
>> +	ip link set eni1np1 netns nssv
>> +	ip link set eni2np1 netns nscl
> 
> This assumes you have systemd renaming interfaces.
> I can find out what the netdev is called from sysfs.
> After you create the nsim device in its sysfs dir
> there will be a dir "net" and in it you'll have
> a subdir with the same name as the netdev.

Thanks, will fix.

> 
>> +	ip netns exec nssv ip addr add '192.168.1.1/24' dev eni1np1
>> +	ip netns exec nscl ip addr add '192.168.1.2/24' dev eni2np1
>> +
>> +	ip netns exec nssv ip link set dev eni1np1 up
>> +	ip netns exec nscl ip link set dev eni2np1 up
>> +	set +e
>> +}
>> +
>> +cleanup_ns()
>> +{
>> +	ip netns del nscl
>> +	ip netns del nssv
>> +}
>> +
>> +###
>> +### Code start
>> +###
>> +
>> +modprobe netdevsim
>> +
>> +# linking
>> +
>> +echo 1 > ${NSIM_DEV_SYS}/new_device
> 
> Use $RANDOM to generate a random device ID.

Will do.

> 
>> +echo "2 0" > ${NSIM_DEV_DFS}1/ports/0/peer 2>/dev/null
>> +if [ $? -eq 0 ]; then
>> +	echo "linking with non-existent netdevsim should fail"
>> +	exit 1
>> +fi
>> +
>> +echo 2 > /sys/bus/netdevsim/new_device
>> +
>> +echo "2 0" > ${NSIM_DEV_DFS}1/ports/0/peer
>> +if [ $? -ne 0 ]; then
>> +	echo "linking netdevsim1 port0 with netdevsim2 port0 should succeed"
>> +	exit 1
>> +fi
>> +
>> +# argument error checking
>> +
>> +echo "2 1" > ${NSIM_DEV_DFS}1/ports/0/peer 2>/dev/null
>> +if [ $? -eq 0 ]; then
>> +	echo "linking with non-existent port in a netdevsim should fail"
>> +	exit 1
>> +fi
>> +
>> +echo "1 0" > ${NSIM_DEV_DFS}1/ports/0/peer 2>/dev/null
>> +if [ $? -eq 0 ]; then
>> +	echo "linking with self should fail"
>> +	exit 1
>> +fi
>> +
>> +echo "2 a" > ${NSIM_DEV_DFS}1/ports/0/peer 2>/dev/null
>> +if [ $? -eq 0 ]; then
>> +	echo "invalid arg should fail"
>> +	exit 1
>> +fi
>> +
>> +# send/recv packets
>> +
>> +socat_check || exit 1
> 
> There's a magic return value for skipping kselftests, 1 means fail.

Thanks, will fix.

Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ